---
title: AudioParam.setTargetAtTime()
slug: Web/API/AudioParam/setTargetAtTime
tags:
  - API
  - AudioParam
  - Method
  - Reference
  - Web Audio API
  - setTargetAtTime
---
<p>{{ APIRef("Web Audio API") }}</p>

<p class="summary">The <code>setTargetAtTime()</code> method of the {{domxref("AudioParam")}} interface schedules the start of a gradual change to the <code>AudioParam</code> value. This is useful for decay or release portions of ADSR envelopes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>paramRef</em> = <em>param</em>.setTargetAtTime(<em>target</em>, <em>startTime</em>, <em>timeConstant</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>The value the parameter will start to transition towards at the given start time.</dd>
 <dt>startTime</dt>
 <dd>The time that the exponential transition will begin, in the same time coordinate system as {{domxref("AudioContext.currentTime")}}. If it is less than or equal to <code>AudioContext.currentTime</code>, the parameter will start changing immediately.</dd>
 <dt>timeConstant</dt>
 <dd>The time-constant value, given in seconds, of an exponential approach to the target value. The larger this value is, the slower the transition will be.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>A reference to this <code>AudioParam</code> object. Some older browser implementations of this interface return void.</p>

<h2 id="Description">Description</h2>

<p>The change starts at the time specified in <code>startTime</code> and exponentially moves towards the value given by the <code>target</code> parameter. The decay rate as defined by the <code>timeConstant</code> parameter is exponential; therefore the value will never reach <code>target</code> completely, but after each timestep of length <code>timeConstant</code>, the value will have approached <code>target</code> by another <math><semantics><mrow><mn>1</mn><mo>-</mo><msup><mi>e</mi><mrow><mo>-</mo><mn>1</mn></mrow></msup><mo>≈</mo><mn>63.2</mn><mtext>%</mtext></mrow><annotation encoding="TeX">1 - e^{-1} \approx 63.2%</annotation></semantics></math>. For the complete formula (which uses a first-order linear continuous time-invariant system), check the <a href="https://webaudio.github.io/web-audio-api/#dom-audioparam-settargetattime">Web Audio specification</a>.</p>

<p>If you absolutely need to reach the target value by a specific time, you can use {{domxref("AudioParam.exponentialRampToValueAtTime()")}}. However, for mathematical reasons, that method does not work if the current value or the target value is <code>0</code>.</p>

<h3 id="Choosing_a_good_timeConstant">Choosing a good <code>timeConstant</code></h3>

<p>As mentioned above, the value changes exponentially, with each <code>timeConstant</code> bringing you another 63.2% toward the target value. You don't have to worry about reaching the target value; once you are close enough, any further changes will be imperceptible to a human listener.</p>

<p>Depending on your use case, getting 95% toward the target value may already be enough; in that case, you could set <code>timeConstant</code> to one third of the desired duration.</p>

<p>For more details, check the following table on how the value changes from 0% to 100% as the time progresses.</p>

<table style="width: auto;">
 <thead>
  <tr>
   <th style="white-space: nowrap;">Time since <code>startTime</code></th>
   <th>Value</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>0 * timeConstant</code></td>
   <td style="text-align: right;">0%</td>
  </tr>
  <tr>
   <td><code>0.5 * timeConstant</code></td>
   <td style="text-align: right;">39.3%</td>
  </tr>
  <tr>
   <td><code>1 * timeConstant</code></td>
   <td style="text-align: right;">63.2%</td>
  </tr>
  <tr>
   <td><code>2 * timeConstant</code></td>
   <td style="text-align: right;">86.5%</td>
  </tr>
  <tr>
   <td><code>3 * timeConstant</code></td>
   <td style="text-align: right;">95.0%</td>
  </tr>
  <tr>
   <td><code>4 * timeConstant</code></td>
   <td style="text-align: right;">98.2%</td>
  </tr>
  <tr>
   <td><code>5 * timeConstant</code></td>
   <td style="text-align: right;">99.3%</td>
  </tr>
  <tr>
   <td><code>n * timeConstant</code></td>
   <td><math><semantics><mrow><mn>1</mn><mo>-</mo><msup><mi>e</mi><mrow><mo>-</mo><mi>n</mi></mrow></msup></mrow><annotation encoding="TeX">1 - e^{-n}</annotation></semantics></math></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>In this example, we have a media source with two control buttons (see the <a class="external external-icon" href="https://github.com/mdn/webaudio-examples/blob/master/audio-param/index.html">webaudio-examples repo</a> for the source code, or <a class="external external-icon" href="https://mdn.github.io/webaudio-examples/audio-param/">view the example live</a>.) When these buttons are pressed, <code>setTargetAtTime()</code> is used to fade the gain value up to 1.0, and down to 0, respectively, with the effect starting after 1 second, and the length of time the effect lasts being controlled by the timeConstant.</p>

<pre class="brush: js;highlight[32,37]">// create audio context
var AudioContext = window.AudioContext || window.webkitAudioContext;
var audioCtx = new AudioContext();

// set basic variables for example
var myAudio = document.querySelector('audio');
var pre = document.querySelector('pre');
var myScript = document.querySelector('script');

pre.innerHTML = myScript.innerHTML;

var atTimePlus = document.querySelector('.at-time-plus');
var atTimeMinus = document.querySelector('.at-time-minus');

// Create a MediaElementAudioSourceNode
// Feed the HTMLMediaElement into it
var source = audioCtx.createMediaElementSource(myAudio);

// Create a gain node and set it's gain value to 0.5
var gainNode = audioCtx.createGain();
gainNode.gain.value = 0.5;
var currGain = gainNode.gain.value;

// connect the AudioBufferSourceNode to the gainNode
// and the gainNode to the destination
source.connect(gainNode);
gainNode.connect(audioCtx.destination);

// set buttons to do something onclick
atTimePlus.onclick = function() {
  currGain = 1.0;
  gainNode.gain.setTargetAtTime(1.0, audioCtx.currentTime + 1, 0.5);
}

atTimeMinus.onclick = function() {
  currGain = 0;
  gainNode.gain.setTargetAtTime(0, audioCtx.currentTime + 1, 0.5);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audioparam-settargetattime', 'setTargetAtTime')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioParam.setTargetAtTime")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
